import socket

# This python script toggles relay 1 on a dS module each time it is run.
# The dS module must be setup to binary mode on the TCP/IP config page.
# Set the IP address and Port number for the dS module, below.


s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

def writeData(data):
    try:
        s.sendall(data)
    except Exception, e:
        print "Error writing message"

def readData(num):
    chunk = ''
    try:
        chunk = s.recv(num)
    except Exception, e:
        print "error reading"

    b = bytearray()
    b.extend(map(ord, chunk))
    return b

IP_ADDRESS = raw_input("Enter IP: ")
PORT = int(raw_input("Enter port: "))

# Try to connect to the module
try:
    print "Connecting"
    s.connect((IP_ADDRESS, PORT))
except Exception, e:
    print e
    s.close()

writeData('\x33\x01')       # Command to get the relay state
relay_data = readData(5)    # Read the data back

# If the relay is off then turn it on if it is on then turn it off
if relay_data[0] > 0:
    print "Relay 1 is on - toggling state"
    writeData('\x31\x01\x00\x00\x00\x00\x00')
else:
    print "Relay 1 is off - toggling state"
    writeData('\x31\x01\x01\x00\x00\x00\x00')
input_data = readData(2)    # Read back the return byte from setting the relay

writeData('\x34\x01')       # Command to get value of input 1
input_data = readData(2)

if input_data[0] > 0:
    print "Input 1 is active"
else :
    print "input 1 is inactive"

try:
    s.close()
except Exception, e:
    print e

print "Disconnected"
