﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Management;
using System.Threading;
using System.Security.Cryptography;

namespace dSexample
{
    public partial class Form1 : Form
    {
        TcpClient clientSocket = new TcpClient();

        struct UdpState
        {
            public System.Net.IPEndPoint EP;
            public System.Net.Sockets.UdpClient UDPClient;
        }
        private UdpState GlobalUDP;
        string aes_passphrase = "This MUST be 32 characters long.";
        private static byte[] aes_iv = new byte[16];
        byte DS1242_MODULEID = 31;
        byte[] nonce = new byte[4];

        public Form1()
        {
            InitializeComponent();
            comboBox_IP.Items.Add("Custom IP");
            comboBox_IP.Sorted = true;
            MessageBox.Show("Please note this example uses the default AES Passphrase of :\nThis MUST be 32 characters long.", "Notice");
            try
            {
                GlobalUDP.UDPClient = new UdpClient();
                GlobalUDP.EP = new System.Net.IPEndPoint(System.Net.IPAddress.Parse("255.255.255.255"), 30303);
                System.Net.IPEndPoint BindEP = new System.Net.IPEndPoint(System.Net.IPAddress.Any, 30303);
                byte[] DiscoverMsg = Encoding.ASCII.GetBytes("Discovery: Who is out there?");

                // Set the local UDP port to listen on
                GlobalUDP.UDPClient.Client.Bind(BindEP);

                // Enable the transmission of broadcast packets without having them be received by ourself
                GlobalUDP.UDPClient.EnableBroadcast = true;
                GlobalUDP.UDPClient.MulticastLoopback = false;

                // Configure ourself to receive discovery responses
                GlobalUDP.UDPClient.BeginReceive(ReceiveCallback, GlobalUDP);

                // Transmit the discovery request message
                GlobalUDP.UDPClient.Send(DiscoverMsg, DiscoverMsg.Length, new System.Net.IPEndPoint(System.Net.IPAddress.Parse("255.255.255.255"), 30303));
            }
            catch { }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

            NetworkStream serverStream = clientSocket.GetStream();
            byte[] stream = { 0x33, 0x01 };                          // request relay 1, but we will use the full packed relay bytes that follow in positions 1 and 2
            send_data(stream);
            stream = read_data();

            if ((stream[4] & 0x0001) == 0) button1.BackColor = Color.WhiteSmoke;
            else button1.BackColor = Color.MistyRose;
            if ((stream[4] & 0x0002) == 0) button2.BackColor = Color.WhiteSmoke;
            else button2.BackColor = Color.MistyRose;
            
	        stream[0] = 0x34;        // change command to get inputs, request input1, but we will use the full packed inputs bytes that follow in position 1
	        stream[1] = 1;
            send_data(stream);
            stream = read_data();

            if ((stream[1] & 0x0001) == 0) IO1.Checked = false; else IO1.Checked = true;
            if ((stream[1] & 0x0002) == 0) IO2.Checked = false; else IO2.Checked = true;
            if ((stream[1] & 0x0004) == 0) IO3.Checked = false; else IO3.Checked = true;
            if ((stream[1] & 0x0008) == 0) IO4.Checked = false; else IO4.Checked = true;

            stream[0] = 0x35;       // read analog inputs
            send_data(stream);
            stream = read_data();

            int x = (stream[0] << 8) + (stream[1]);
            adc1.Text = string.Format("{0}", x);
            x = (stream[2] << 8) + (stream[3]);
            adc2.Text = string.Format("{0}", x);
            x = (stream[4] << 8) + (stream[5]);

            stream[0] = 0x36;   // Get Timer/ Counter 1
            stream[1] = 0x01;
            send_data(stream);
            stream = read_data();
            labelCounter1.Text = string.Format("Counter 1 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture1.Text = string.Format("Capture 1 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x02;
            send_data(stream);
            stream = read_data();
            labelCounter2.Text = string.Format("Counter 2 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture2.Text = string.Format("Capture 2 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x03;
            send_data(stream);
            stream = read_data();
            labelCounter3.Text = string.Format("Counter 3 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture3.Text = string.Format("Capture 3 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x04;
            send_data(stream);
            stream = read_data();
            labelCounter4.Text = string.Format("Counter 4 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture4.Text = string.Format("Capture 4 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x05;
            send_data(stream);
            stream = read_data();
            labelCounter5.Text = string.Format("Counter 5 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture5.Text = string.Format("Capture 5 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x06;
            send_data(stream);
            stream = read_data();
            labelCounter6.Text = string.Format("Counter 6 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture6.Text = string.Format("Capture 6 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x07;
            send_data(stream);
            stream = read_data();
            labelCounter7.Text = string.Format("Counter 7 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture7.Text = string.Format("Capture 7 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));

            stream[0] = 0x36;
            stream[1] = 0x08;
            send_data(stream);
            stream = read_data();
            labelCounter8.Text = string.Format("Counter 8 : {0}", ((stream[0] << 24) | (stream[1] << 16) | (stream[2] << 8) | stream[3]));
            labelCapture8.Text = string.Format("Capture 8 : {0}", ((stream[4] << 24) | (stream[5] << 16) | (stream[6] << 8) | stream[7]));
        }

        private void button_Click(object sender, EventArgs e)
        {
            byte[] stream = new byte[16];

            Array.Copy(nonce, 0, stream, 12, 4); //send latest nonce
            Button button = (Button)sender;
            string buttonId = button.Name;  //name I.E button1
            byte button_number = Convert.ToByte(buttonId.Substring(6)); //number of button I.E 12

            stream[0] = 0x31;
            stream[1] = (byte) (button_number);
            if (button.BackColor == Color.MistyRose) stream[2] = 0;
            else stream[2] = 1;

            send_data(stream);
            stream = read_data();
            Array.Copy(stream, 12, nonce, 0, 4); //extract next nonce
        }

        private void IO_Click(object sender, EventArgs e)
        {
            byte[] stream = new byte[16];

            Array.Copy(nonce, 0, stream, 12, 4); //send latest nonce
            RadioButton button = (RadioButton)sender;
            string buttonId = button.Name;  //name I.E button1
            byte button_number = Convert.ToByte(buttonId.Substring(2)); //number of button I.E 12

            stream[0] = 0x32;
            stream[1] = (byte)(button_number);
            if (button.Checked == true) stream[2] = 0;
            else stream[2] = 1;

            send_data(stream);
            stream = read_data();
            Array.Copy(stream, 12, nonce, 0, 4); //extract next nonce
        }

        public void ReceiveCallback(IAsyncResult ar)
        {
            UdpState MyUDP = (UdpState)ar.AsyncState;
            byte[] data;
            int line_start = 0;
            int line_end;
            string hostname = null;
            string ipaddress = "";
            string port = "";
            int module_id = 0;

            // Obtain the UDP message body and convert it to a string, with remote IP address attached as well
            data = (MyUDP.UDPClient.EndReceive(ar, ref MyUDP.EP));

            if (System.Text.Encoding.UTF8.GetString(data) != "Discovery: Who is out there?")
            {
                do
                {
                    line_end = Array.IndexOf<byte>(data, 0x0a, line_start);
                    switch (data[line_start])
                    {
                        case 4: hostname = System.Text.Encoding.UTF8.GetString(data, line_start + 1, line_end - line_start);
                            hostname = hostname.TrimEnd();
                            break;
                        case 5: ipaddress = data[line_start + 1].ToString() + '.' + data[line_start + 2].ToString() + '.' + data[line_start + 3].ToString() + '.' + data[line_start + 4].ToString();
                            break;
                        case 64: module_id = data[line_start + 1];
                            break;
                        case 65: port = ((data[line_start + 1] << 8) + data[line_start + 2]).ToString();
                            break;
                        default:  
                            break;
                    }
                    line_start = line_end + 1;
                }
                while (line_start < data.Length);
                if ((module_id == DS1242_MODULEID) && (hostname != null)) comboBox_IP.BeginInvoke(new MethodInvoker(delegate() { comboBox_IP.Items.Add(ipaddress +":"+ port + " - " + hostname); }));
            }
            // Configure the UdpClient class to accept more messages, if they arrive
            MyUDP.UDPClient.BeginReceive(ReceiveCallback, MyUDP);
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            byte[] stream = new byte[16]; 

            if (clientSocket.Connected == true)
            {
                timer1.Enabled = false;
                clientSocket.Close();
                clientSocket = new TcpClient();
            }
            if (comboBox_IP.Text == "Custom IP")
            {
                Form2 secondForm = new Form2();
                secondForm.ShowDialog();
                if (GlobalClass.ipaddress != "0.0.0.0")
                {
                    clientSocket.Connect(GlobalClass.ipaddress,GlobalClass.port);
                }
            }
            else
            {
                GlobalClass.ipaddress = comboBox_IP.Text.Substring(0, comboBox_IP.Text.IndexOf(':'));
                GlobalClass.port = Convert.ToInt16(comboBox_IP.Text.Substring(comboBox_IP.Text.IndexOf(':') + 1, comboBox_IP.Text.IndexOf(' ') - comboBox_IP.Text.IndexOf(':')));
                clientSocket.Connect(GlobalClass.ipaddress, GlobalClass.port);
            }
            if (clientSocket.Connected == true)
            {
                clientSocket.ReceiveTimeout = 500;
                timer1.Enabled = true;
                stream[0] = 0x30;        // get nonce, this is a random number in bytes 12-15 that prevents data packets being merely copied to cause effects (like switch relays)
                send_data(stream);       // a new nonce is sent with every set state
                stream = read_data();
                Array.Copy(stream, 12, nonce, 0, 4);
            }
        }

        public void send_data(byte[] data)
        {
            NetworkStream serverStream = clientSocket.GetStream();
            byte[] data_and_iv = new byte[32];
            
            data = Encrypt(data, aes_passphrase);
            Array.Copy(aes_iv, 0, data_and_iv, 0, 16);
            Array.Copy(data, 0, data_and_iv, aes_iv.Length, 16);
            serverStream.Write(data_and_iv, 0, data_and_iv.Length);
        }

        public byte[] read_data() //reads a fixed data length of 16 bytes
        {
            NetworkStream serverStream = clientSocket.GetStream();
            byte[] instream = new byte[32];
            byte[] temp = new byte[16];

            try
            {
                serverStream.Read(instream, 0, 32);
            }
            catch (Exception e)
            {
                timer1.Stop();
                MessageBox.Show("Read time out, make sure that dS1242 is in AES binary mode.");
                System.Windows.Forms.Application.Exit();
            }

            Array.Copy(instream, 0, aes_iv, 0, 16);
            Array.Copy(instream, 16, temp, 0, 16);
            instream = Decrypt(temp, aes_passphrase);
            return instream;
        }

        public static byte[] Encrypt(byte[] plain, string password)
        {
            MemoryStream memoryStream;
            CryptoStream cryptoStream;
            Rijndael rijndael = Rijndael.Create();
            rijndael.Mode = CipherMode.CBC;
            rijndael.Key = Encoding.ASCII.GetBytes(password);
            rijndael.GenerateIV();
            aes_iv = rijndael.IV;               //iv copied for sending to ds board
            memoryStream = new MemoryStream();
            cryptoStream = new CryptoStream(memoryStream, rijndael.CreateEncryptor(), CryptoStreamMode.Write);
            cryptoStream.Write(plain, 0, plain.Length);
            cryptoStream.Close();
            return memoryStream.ToArray();
        }

        public static byte[] Decrypt(byte[] cipher, string password)
        {
            MemoryStream memoryStream;
            CryptoStream cryptoStream;
            Rijndael rijndael = Rijndael.Create();
            rijndael.Mode = CipherMode.CBC;
            rijndael.Key = Encoding.ASCII.GetBytes(password);
            rijndael.IV = aes_iv;
            rijndael.Padding = PaddingMode.Zeros;
            memoryStream = new MemoryStream();
            cryptoStream = new CryptoStream(memoryStream, rijndael.CreateDecryptor(), CryptoStreamMode.Write);
            cryptoStream.Write(cipher, 0, cipher.Length);
            cryptoStream.Close();
            return memoryStream.ToArray();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }
}
