package ds378test;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import javax.crypto.Cipher;
import javax.swing.JOptionPane;
import javax.swing.Timer;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author devantech
 */
public class DS378UI extends javax.swing.JFrame implements NotificationInterface {

    private NetworkUDPScan n_manager;
    private DS378Connection module_connection;
    private String ip_string;
    private Timer timer1;

    Color on;
    Color off;
    
    ActionListener button_action = new ActionListener() {                        // This is the action listener that will grab the button clicks
        @Override
        public void actionPerformed(ActionEvent e) {
            if (module_connection != null) {
                byte relay = 0;
                if (e.getSource() == buttonRelay1) {
                    relay = 1;
                } else if (e.getSource() == buttonRelay2) {
                    relay = 2;
                } else if (e.getSource() == buttonRelay3) {
                    relay = 3;
                } else if (e.getSource() == buttonRelay4) {
                    relay = 4;
                } else if (e.getSource() == buttonRelay5) {
                    relay = 5;
                } else if (e.getSource() == buttonRelay6) {
                    relay = 6;
                } else if (e.getSource() == buttonRelay7) {
                    relay = 7;
                } else if (e.getSource() == buttonRelay8) {
                    relay = 8;
                }
                if (module_connection.connected == true) {
                    byte[] state = module_connection.getRelayStates(relay);     // Get the state of the individual realy
                    if ((state[0] & (byte) 0x01) == 1) {                        // Then set it to the opposite
                        module_connection.setRelay(relay, (byte) 0);
                    } else {
                        module_connection.setRelay(relay, (byte) 1);
                    }
                }
            }
        }
    };

    /**
     * Creates new form DS378UI
     */
    public DS378UI() {
        initComponents();
        n_manager = new NetworkUDPScan();
        buttonRelay1.addActionListener(button_action);                              // Register actions for buttons
        buttonRelay2.addActionListener(button_action);
        buttonRelay3.addActionListener(button_action);
        buttonRelay4.addActionListener(button_action);
        buttonRelay5.addActionListener(button_action);
        buttonRelay6.addActionListener(button_action);
        buttonRelay7.addActionListener(button_action);
        buttonRelay8.addActionListener(button_action);

        try {
            long len = Cipher.getMaxAllowedKeyLength("AES/CBC/PKCS5Padding");
            if (len < 256) {
                JOptionPane.showMessageDialog(this, "Java unlimited cryptography policy is not installed, can not send encrypted messages to module. Please see readme file that ships with this software for details");
                System.exit(0);
            }
        } catch (NoSuchAlgorithmException ex) {

        }
        
        on = new Color(226, 172, 163);
        off = new Color(163, 187, 226);
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonRelay1 = new javax.swing.JButton();
        buttonRelay2 = new javax.swing.JButton();
        buttonRelay3 = new javax.swing.JButton();
        buttonRelay4 = new javax.swing.JButton();
        buttonRelay5 = new javax.swing.JButton();
        buttonRelay6 = new javax.swing.JButton();
        buttonRelay7 = new javax.swing.JButton();
        buttonRelay8 = new javax.swing.JButton();
        modules_combobox = new javax.swing.JComboBox<>();
        labelInput1 = new javax.swing.JLabel();
        labelInput2 = new javax.swing.JLabel();
        labelInput3 = new javax.swing.JLabel();
        labelInput4 = new javax.swing.JLabel();
        labelInput5 = new javax.swing.JLabel();
        labelInput6 = new javax.swing.JLabel();
        labelInput7 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        labelCounter1 = new javax.swing.JLabel();
        labelCounter2 = new javax.swing.JLabel();
        labelCounter3 = new javax.swing.JLabel();
        labelCounter4 = new javax.swing.JLabel();
        labelCounter5 = new javax.swing.JLabel();
        labelCounter6 = new javax.swing.JLabel();
        labelCounter7 = new javax.swing.JLabel();
        labelCounter8 = new javax.swing.JLabel();
        labelCapture1 = new javax.swing.JLabel();
        labelCapture2 = new javax.swing.JLabel();
        labelCapture3 = new javax.swing.JLabel();
        labelCapture4 = new javax.swing.JLabel();
        labelCapture5 = new javax.swing.JLabel();
        labelCapture6 = new javax.swing.JLabel();
        labelCapture7 = new javax.swing.JLabel();
        labelCapture8 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        buttonRelay1.setText("Relay 1");

        buttonRelay2.setText("Relay 2");

        buttonRelay3.setText("Relay 3");

        buttonRelay4.setText("Relay 4");

        buttonRelay5.setText("Relay 5");

        buttonRelay6.setText("Relay 6");

        buttonRelay7.setText("Relay 7");

        buttonRelay8.setText("Relay 8");

        modules_combobox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Select Module" }));
        modules_combobox.addPopupMenuListener(new javax.swing.event.PopupMenuListener() {
            public void popupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {
                modules_comboboxPopupMenuWillBecomeVisible(evt);
            }
            public void popupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {
                modules_comboboxPopupMenuWillBecomeInvisible(evt);
            }
            public void popupMenuCanceled(javax.swing.event.PopupMenuEvent evt) {
            }
        });

        labelInput1.setText("Analogue 1:");

        labelInput2.setText("Analogue 2:");

        labelInput3.setText("Analogue 3:");

        labelInput4.setText("Analogue 4:");

        labelInput5.setText("Analogue 5:");

        labelInput6.setText("Analogue 6:");

        labelInput7.setText("Analogue 7:");

        labelCounter1.setText("Counter 1 :");

        labelCounter2.setText("Counter 2 : ");

        labelCounter3.setText("Counter 3 :");

        labelCounter4.setText("Counter 4 :");

        labelCounter5.setText("Counter 5 : ");

        labelCounter6.setText("Counter 6 : ");

        labelCounter7.setText("Counter 7 : ");

        labelCounter8.setText("Counter 8 : ");

        labelCapture1.setText("Capture 1 : ");

        labelCapture2.setText("Capture 2 : ");

        labelCapture3.setText("Capture 3 : ");

        labelCapture4.setText("Capture 4 : ");

        labelCapture5.setText("Capture 5 : ");

        labelCapture6.setText("Capture 6 : ");

        labelCapture7.setText("Capture 7 : ");

        labelCapture8.setText("Capture 8 : ");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(buttonRelay1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(modules_combobox, 0, 212, Short.MAX_VALUE)
                                    .addComponent(buttonRelay2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(buttonRelay3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(buttonRelay4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(buttonRelay5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(buttonRelay6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(buttonRelay7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(buttonRelay8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(labelInput7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelInput6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelInput5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelInput4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelInput3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelInput2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelInput1, javax.swing.GroupLayout.DEFAULT_SIZE, 121, Short.MAX_VALUE)))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(labelCounter8, javax.swing.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE)
                                    .addComponent(labelCounter7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(labelCounter1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(labelCapture1, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addGap(12, 12, 12)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(labelCapture2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(labelCapture3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(labelCapture4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(labelCapture5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(labelCapture6, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(labelCapture7, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(labelCapture8, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE))))))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(modules_combobox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonRelay1)
                    .addComponent(labelInput1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonRelay2)
                    .addComponent(labelInput2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonRelay3)
                    .addComponent(labelInput3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonRelay4)
                    .addComponent(labelInput4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonRelay5)
                    .addComponent(labelInput5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonRelay6)
                    .addComponent(labelInput6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonRelay7)
                    .addComponent(labelInput7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonRelay8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter1)
                    .addComponent(labelCapture1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter2)
                    .addComponent(labelCapture2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter3)
                    .addComponent(labelCapture3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter4)
                    .addComponent(labelCapture4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter5)
                    .addComponent(labelCapture5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter6)
                    .addComponent(labelCapture6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter7)
                    .addComponent(labelCapture7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelCounter8)
                    .addComponent(labelCapture8))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void modules_comboboxPopupMenuWillBecomeInvisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_modules_comboboxPopupMenuWillBecomeInvisible

        if (modules_combobox.getSelectedIndex() == 0) {
            return; // return because item 0 is never a module, its the text "Select Module"
        }
        ip_string = modules_combobox.getSelectedItem().toString().substring(modules_combobox.getSelectedItem().toString().lastIndexOf(" ") + 1); // This will contain the ip address and port seperated by a colon

        // Ip address is first part of string before : port is second part of string
        module_connection = new DS378Connection(ip_string.substring(0, ip_string.lastIndexOf(":")),
                Integer.valueOf(ip_string.substring(ip_string.lastIndexOf(":") + 1)));

        if (module_connection.connected == true) {
            module_connection.registerForNotifications(this);                   // Register to receive notifications
            module_connection.getStatus();
            timer1 = new Timer(300, new ActionListener() {                      // Setup timer
                @Override
                public void actionPerformed(ActionEvent e) {
                    byte[] states = module_connection.getRelayStates((byte) 0x01);         // Set the colours of the relay buttons
                    if ((states[4] & (byte) 0x01) > 0) {
                        buttonRelay1.setBackground(on);
                    } else {
                        buttonRelay1.setBackground(off);
                    }
                    if ((states[4] & (byte) 0x02) != 0) {
                        buttonRelay2.setBackground(on);
                    } else {
                        buttonRelay2.setBackground(off);
                    }
                    if ((states[4] & (byte) 0x04) != 0) {
                        buttonRelay3.setBackground(on);
                    } else {
                        buttonRelay3.setBackground(off);
                    }
                    if ((states[4] & (byte) 0x08) != 0) {
                        buttonRelay4.setBackground(on);
                    } else {
                        buttonRelay4.setBackground(off);
                    }
                    if ((states[4] & (byte) 0x10) != 0) {
                        buttonRelay5.setBackground(on);
                    } else {
                        buttonRelay5.setBackground(off);
                    }
                    if ((states[4] & (byte) 0x20) != 0) {
                        buttonRelay6.setBackground(on);
                    } else {
                        buttonRelay6.setBackground(off);
                    }
                    if ((states[4] & (byte) 0x40) != 0) {
                        buttonRelay7.setBackground(on);
                    } else {
                        buttonRelay7.setBackground(off);
                    }
                    if ((states[4] & (byte) 0x80) != 0) {
                        buttonRelay8.setBackground(on);
                    } else {
                        buttonRelay8.setBackground(off);
                    }

                    int[] analogue = module_connection.getInputs();             // Get the values of the analogue ports
                    labelInput1.setText("Analogue 1 : " + String.valueOf(analogue[0]));
                    labelInput2.setText("Analogue 2 : " + String.valueOf(analogue[1]));
                    labelInput3.setText("Analogue 3 : " + String.valueOf(analogue[2]));
                    labelInput4.setText("Analogue 4 : " + String.valueOf(analogue[3]));
                    labelInput5.setText("Analogue 5 : " + String.valueOf(analogue[4]));
                    labelInput6.setText("Analogue 6 : " + String.valueOf(analogue[5]));
                    labelInput7.setText("Analogue 7 : " + String.valueOf(analogue[6]));

                    int[] counter = new int[2];
                    counter = module_connection.getCounterTimer((byte) 0x01);                    // Get the Timer/ Counter values
                    labelCounter1.setText("Counter 1 : " + String.valueOf(counter[0]));         // Display them
                    labelCapture1.setText("Capture 1 : " + String.valueOf(counter[1]));
                    counter = module_connection.getCounterTimer((byte) 0x02);
                    labelCounter2.setText("Counter 2 : " + String.valueOf(counter[0]));
                    labelCapture2.setText("Capture 2 : " + String.valueOf(counter[1]));
                    counter = module_connection.getCounterTimer((byte) 0x03);
                    labelCounter3.setText("Counter 3 : " + String.valueOf(counter[0]));
                    labelCapture3.setText("Capture 3 : " + String.valueOf(counter[1]));
                    counter = module_connection.getCounterTimer((byte) 0x04);
                    labelCounter4.setText("Counter 4 : " + String.valueOf(counter[0]));
                    labelCapture4.setText("Capture 4 : " + String.valueOf(counter[1]));
                    counter = module_connection.getCounterTimer((byte) 0x05);
                    labelCounter5.setText("Counter 5 : " + String.valueOf(counter[0]));
                    labelCapture5.setText("Capture 5 : " + String.valueOf(counter[1]));
                    counter = module_connection.getCounterTimer((byte) 0x06);
                    labelCounter6.setText("Counter 6 : " + String.valueOf(counter[0]));
                    labelCapture6.setText("Capture 6 : " + String.valueOf(counter[1]));
                    counter = module_connection.getCounterTimer((byte) 0x07);
                    labelCounter7.setText("Counter 7 : " + String.valueOf(counter[0]));
                    labelCapture7.setText("Capture 7 : " + String.valueOf(counter[1]));
                    counter = module_connection.getCounterTimer((byte) 0x08);
                    labelCounter8.setText("Counter 8 : " + String.valueOf(counter[0]));
                    labelCapture8.setText("Capture 8 : " + String.valueOf(counter[1]));
                }
            });
            timer1.start();
        }
    }//GEN-LAST:event_modules_comboboxPopupMenuWillBecomeInvisible

    private void modules_comboboxPopupMenuWillBecomeVisible(javax.swing.event.PopupMenuEvent evt) {//GEN-FIRST:event_modules_comboboxPopupMenuWillBecomeVisible
        // Display the modules received from the UDP scan in the combo box
        modules_combobox.removeAllItems();
        modules_combobox.addItem("Select Module");
        ArrayList<String> mods = n_manager.getModuleList();
        mods.forEach((str) -> {
            modules_combobox.addItem(str);
        });
    }//GEN-LAST:event_modules_comboboxPopupMenuWillBecomeVisible

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(DS378UI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(DS378UI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(DS378UI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(DS378UI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new DS378UI().setVisible(true);
            }
        });
    }

    @Override
    public void networkError(String error) {            // Implemented form NotificationInterface.java
        if (timer1 != null) {
            timer1.stop();
        }
        module_connection.close();
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                JOptionPane.showOptionDialog(null, error, "Test", JOptionPane.DEFAULT_OPTION,
                        JOptionPane.INFORMATION_MESSAGE, null, null, null);
                System.exit(0);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonRelay1;
    private javax.swing.JButton buttonRelay2;
    private javax.swing.JButton buttonRelay3;
    private javax.swing.JButton buttonRelay4;
    private javax.swing.JButton buttonRelay5;
    private javax.swing.JButton buttonRelay6;
    private javax.swing.JButton buttonRelay7;
    private javax.swing.JButton buttonRelay8;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel labelCapture1;
    private javax.swing.JLabel labelCapture2;
    private javax.swing.JLabel labelCapture3;
    private javax.swing.JLabel labelCapture4;
    private javax.swing.JLabel labelCapture5;
    private javax.swing.JLabel labelCapture6;
    private javax.swing.JLabel labelCapture7;
    private javax.swing.JLabel labelCapture8;
    private javax.swing.JLabel labelCounter1;
    private javax.swing.JLabel labelCounter2;
    private javax.swing.JLabel labelCounter3;
    private javax.swing.JLabel labelCounter4;
    private javax.swing.JLabel labelCounter5;
    private javax.swing.JLabel labelCounter6;
    private javax.swing.JLabel labelCounter7;
    private javax.swing.JLabel labelCounter8;
    private javax.swing.JLabel labelInput1;
    private javax.swing.JLabel labelInput2;
    private javax.swing.JLabel labelInput3;
    private javax.swing.JLabel labelInput4;
    private javax.swing.JLabel labelInput5;
    private javax.swing.JLabel labelInput6;
    private javax.swing.JLabel labelInput7;
    private javax.swing.JComboBox<String> modules_combobox;
    // End of variables declaration//GEN-END:variables
}
