/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dscriptmodbus;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import javax.swing.JButton;

/**
 *
 * @author James Henderson
 */
public class DownstreamRelayButtonAction extends ControlAction implements ActionListener{

    byte relay_number;
    
    public DownstreamRelayButtonAction(byte r) {
        this.relay_number = r;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        try {
            JButton b = (JButton) e.getSource();
            if (b.getBackground().getRGB() == off.getRGB()) {
                connection.setDownstreamRelayToState(relay_number, (byte) 0xff);
            } else {
                connection.setDownstreamRelayToState(relay_number, (byte) 0x00);
            }
        } catch (IOException ex) {
            ActionEvent error = new ActionEvent(this, 0, "Error setting state of downstream relay number " + String.valueOf(relay_number));
            error_action.actionPerformed(e);
        }
    }
}
