/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dscriptmodbus;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import javax.swing.JCheckBox;

/**
 *
 * @author james
 */
public class IOCheckBoxAction extends ControlAction implements ActionListener {

    private final byte io;
    
    public IOCheckBoxAction(byte io) {
        this.io = io;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        try {
            JCheckBox cb = (JCheckBox) e.getSource();
            if (cb.isSelected()) {
                connection.setIOToState(io, (byte) 0xFF);
            } else {
                connection.setIOToState(io, (byte) 0x00);
            }
        } catch (IOException ex) {
            ActionEvent error = new ActionEvent(this, 0, "Failed to set state of io " + String.valueOf(io));
            error_action.actionPerformed(e);
        }
    }
}
